import array
import struct

with open('secret.lzma.encrypted', 'rb') as input:
    buf = input.read(35680)
    iv_data = array.array('B', buf[112:128]).tostring()
    iv_arr = bytearray(iv_data)

    # only 14 first bytes are relevant
    decrypted_data = '5d00008000ffffffffffffffff00BAAD'.decode("hex")
    decrypted_arr = bytearray(decrypted_data)
    encrypted_data = array.array('B', buf[128:144]).tostring()
    intermediate_data = b''

    for i in range(4):
        idx = i * 4
        l = [None] * 4

        for j in range(4):
            l[4-j-1] = decrypted_arr[idx + j] ^ iv_arr[16 - (idx + j) - 1]

        tmp = struct.pack('4B', l[0], l[1], l[2], l[3])
        c = struct.unpack('>I', tmp)[0]
        a4 = struct.unpack('<I', encrypted_data[idx:(idx+4)])[0]
        a5 = c ^ a4
        intermediate_data += struct.pack('<I', a5)

    print(map(ord, intermediate_data[0:14]))
