import sys

OPCODE_SYMBOLS = {
        'add': '+',
        'addi': '+',
        'and': '&',
        'andi': '&',
        'or': '|',
        'xor': '^',
        'xori': '^',
        'sub': '-',
        'srl': '>>',
        'srli': '>>',
        'sll': '<<',
        'sltu': '<',
}

REGS = {
#    's2': '0xadaaa9aa',
#    't0': '0x52555655'
    's2': 'A',
    't0': 'B',
    'a3': 'K1',
    't5': 'K3',
    't4': 'K0',
    't2': 'K2',
}

#'blob': '(a3 & B) | (t5 & A)'

def get_reg(r):
    #print('r = %s' % r)
    if r in REGS:
        return REGS[r]
    else:
        return r

with open(sys.argv[1]) as fp:
    for line in iter(fp.readline, ''):
        line = line.strip('\n')
        keyword = line.split('\t')
        #print keyword[0]
#        print "//%s" % line
        k0 = keyword[0]
        if k0 == 'lw' or k0 == 'lui' or k0 == 'lbu':
            args = keyword[1].split(',')
            a1 = get_reg(args[1])
            REGS[args[0]] = a1
            #print ("%s = %s" % (args[0], args[1]))#, keyword[2])
        elif (k0 == 'addi'
            or k0 == 'add'
            or k0 == 'and'
            or k0 == 'andi'
            or k0 == 'sub'
            or k0 == 'or'
            or k0 == 'srl'
            or k0 == 'srli'
            or k0 == 'sll'
            or k0 == 'xori'
            or k0 == 'sltu'
            or k0 == 'xor'):
            args = keyword[1].split(',')
            a1 = get_reg(args[1])
            a2 = get_reg(args[2])
            #print ("%s = %s %s %s" % (args[0], args[1], OPCODE_SYMBOLS[k0], args[2]))#, keyword[2])
            if k0 == 'sll':
                a2 = '(%s & 0x1f)' % a2
            REGS[args[0]] = "(%s) %s (%s)" % (a1, OPCODE_SYMBOLS[k0], a2)
        elif k0 == 'sb':
            raise Exception("sb")
            args = keyword[1].split(',')
            #print ("%s = %s" % (args[1], args[0]))
        #else:
            #print(line)

for r in REGS:
    print("%s = %s" % (r, REGS[r]))
