#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

unsigned char get_char(unsigned char c)
{
    if (c >= 10)
        return c + 'a' - 10;
    else
        return c + '0';
}

unsigned char get_nibble(unsigned char c)
{
    if (c >= 'a')
        return c - 'a' + 10;
    else if (c >= 'A')
        return c - 'A' + 10;
    else if (c >= '0')
        return c - '0';
}

// "@sstic.org"
unsigned char *sstic_nibbles = "4073737469632e6f7267";

int get_chars(unsigned char *key)
{
    printf("%s: ", key);

    int keylen = strlen(key);
    int str_len = strlen(sstic_nibbles);

    for (int i=0; i<str_len; i++) {
        unsigned char c = get_nibble(key[i % keylen]);
        unsigned char c2 = get_nibble(sstic_nibbles[i]);

        //printf("%hhx %hhx\n", c, c2);

        unsigned char res = (c + c2) % 16;
        printf("%c", get_char(res));
    }
    printf("\n");
}


int main(int argc, char **argv)
{
    if (argc > 1)
        sstic_nibbles = argv[1];

    get_chars("5571C2017");
    get_chars("571C20175");
    get_chars("71C201755");
    get_chars("1C2017557");
    get_chars("C20175571");
    get_chars("20175571C");
    get_chars("0175571C2");
    get_chars("175571C20");
    get_chars("75571C201");
}
