#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

unsigned char *msg = 
"cefec06    b   a  e   0   cb519c4\n"
"6     9 434 a4d 12   660e 4     4\n"
"4 d94 f 9 bf f   02 b   a f 287 4\n"
"f 01d 1 2 65   0   0   65 7 183 6\n"
"a fd6 b   7 e7 5  a     5 d d4b c\n"
"f     6   7  a  6   e   6 3     3\n"
"c56b0b4 0 8 3 9 9 0 4 5 c d186a57\n"
"        60 3  8c      a 9        \n"
"2     6 214 9c b 20   d e80  65f \n"
"  422       f e95 b3   6 1 16e  8\n"
"a    49eb 157  2  d  a  96d5  f  \n"
"d    9   2d   f4   5  a   d  6d2 \n"
"a   b55  cf36d6b657658a8abeca0 fc\n"
"  8  a  73   1  5   3 c 2c    7 5\n"
" 0 3 a4 0  2c58   86   1 f 2  56 \n"
" 6 041 a   e   8  3f   3791 7   4\n"
"     6558bab a   e13   d 4 16 0  \n"
" f1 27   2 c  90 8829bb1 f8  431 \n"
" 4b3 7e c    9 26  5e5 70e  c 9  \n"
"35 d61   e 9 3 a c2f c     f 7dc \n"
"26   ad 0 4d b f4   a938ac9a7   3\n"
"7   cc e  92    431 6 6   d   4c5\n"
"  8 f a  0da9  a0f  23  6 a3  8d \n"
"a  e6  8  8b 66   24   6 92 c   e\n"
"ce80 5ba a c   d 2 5bd 81e52f c 3\n"
"        c   8f  f  3d   6   d 2  \n"
"228caa6   e2 90   6 8b3ab 5 4c973\n"
"a     8   d  96f9   b   e   2b7e \n"
"0 294 e  7   0    44 0  2061d2  9\n"
"0 40c 9   fb 44 10  91bcc4  2 44 \n"
"3 829 5  1 c0   4   8   6e  f 08d\n"
"e     b     07 2b a6b   0  a8c7  \n"
"fd0ca91 26ad 6     9  3    a   9 \n";

int matrix[35][35];

unsigned char *key = "5571C2017";
unsigned char key_len = 9;


unsigned char get_char(unsigned char c)
{
    if (c >= 10)
        return c + 'a' - 10;
    else
        return c + '0';
}

int get_nibble(unsigned char c)
{
    if (c >= 'a' && c <= 'f')
        return c - 'a' + 10;
    else if (c >= 'A' && c <= 'F')
        return c - 'A' + 10;
    else if (c >= '0' && c <= '9')
        return c - '0';
    else
        return -1;
}

int mod(int a, int b)
{
    int r = a % b;
    return r < 0 ? r + b : r;
}

void print_mail(char mail_hex[1000])
{
    printf("mail is : ");
    unsigned char c;
    for (int j=0; mail_hex[j] != '\0'; j+=2) {
        sscanf(&mail_hex[j], "%02hhx", &c);
        printf("%c", c);
    }
    printf("@sstic.org\n");
}

void find_path(int i, int j, char path[1000], int sol_idx, int matrix[35][35], int key_idx, char mail_hex[1000])
{
    int matrix_cp[35][35];
    memcpy(matrix_cp, matrix, 35*35*sizeof(int));
    //printf("path: idx=%d, x%sy\n", sol_idx, path);

    int n = matrix_cp[i][j];

    if (n == -1)
        return;

    if (i == 22 && j == 19) {
        if (key_idx == 3) {
            printf("path is : %s\n", path);
            print_mail(mail_hex);
        }
        return;
    }
    
    matrix_cp[i][j] = -1;

    char path_cp[1000];
    memcpy(path_cp, path, 1000);
    path_cp[sol_idx] = get_char(n);

    unsigned char key_nibble = get_nibble(key[key_idx % key_len]);

    char mail_hex_cp[1000];
    memcpy(mail_hex_cp, mail_hex, 1000);
    mail_hex_cp[sol_idx] = get_char(mod(n - key_nibble, 16));

    // we must be <= 0x7f
    if ((sol_idx % 2 == 0) && (mail_hex_cp[sol_idx] >= '8'))
        return;

    find_path(i, j+1, path_cp, sol_idx+1, matrix_cp, (key_idx+1) % key_len, mail_hex_cp);
    find_path(i, j-1, path_cp, sol_idx+1, matrix_cp, (key_idx+1) % key_len, mail_hex_cp);
    find_path(i+1, j, path_cp, sol_idx+1, matrix_cp, (key_idx+1) % key_len, mail_hex_cp);
    find_path(i-1, j, path_cp, sol_idx+1, matrix_cp, (key_idx+1) % key_len, mail_hex_cp);
}

int main(void)
{
    int msg_len = strlen(msg);
    int i = 1;
    int j = 1;

    for (int idx=0; idx<35; idx++) {
        for (int idx2=0; idx2<35; idx2++) {
            matrix[idx][idx2] = -1;
        }
    }

    for (int idx=0; idx<msg_len; idx++) {
        if (msg[idx] == '\n') {
            i=1;
            j++;
        } else {
            matrix[i][j] = get_nibble(msg[idx]);
            i++;
        }
    }

    char path[1000];
    memset(path, 0, 1000);
    char mail_hex[1000];
    memset(mail_hex, 0, 1000);

    find_path(1, 24, path, 0, matrix, 0, mail_hex);
}
